<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>ProjectACES: include/dijkstra.hpp File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">ProjectACES
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">dijkstra.hpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>File that contains the declaration of the struct <a class="el" href="structDijkstra__node.html" title="Dijkstra_node struct.">Dijkstra_node</a> and class <a class="el" href="classDijkstra.html" title="Dijkstra class.">Dijkstra</a>.  
<a href="#details">More...</a></p>
<div class="textblock"><div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dyncontent">
<div class="center"><img src="dijkstra_8hpp__dep__incl.png" border="0" usemap="#ainclude_2dijkstra_8hppdep" alt=""/></div>
<map name="ainclude_2dijkstra_8hppdep" id="ainclude_2dijkstra_8hppdep">
<area shape="rect" title="File that contains the declaration of the struct Dijkstra_node and class Dijkstra." alt="" coords="199,5,349,32"/>
<area shape="rect" href="dijkstra_8cpp.html" title="File which contains the implementation for methods in dijkstra.hpp." alt="" coords="5,155,127,181"/>
<area shape="rect" href="IO__dijkstra_8cpp.html" title="File which contains the implementation for methods in IO_dijkstra.hpp." alt="" coords="151,155,293,181"/>
<area shape="rect" href="main_8cpp.html" title=" " alt="" coords="317,155,423,181"/>
<area shape="rect" href="IO__dijkstra_8hpp.html" title="File that contains the methods used to get inputs from user (files, manual inputs,..." alt="" coords="189,80,359,107"/>
<area shape="rect" href="test__dijkstra_8cpp.html" title="File that contains the definitions of the tests used." alt="" coords="447,155,613,181"/>
</map>
</div>
</div>
<p><a href="dijkstra_8hpp_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structDijkstra__node.html">Dijkstra_node</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="structDijkstra__node.html" title="Dijkstra_node struct.">Dijkstra_node</a> struct.  <a href="structDijkstra__node.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDijkstra.html">Dijkstra</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classDijkstra.html" title="Dijkstra class.">Dijkstra</a> class.  <a href="classDijkstra.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr><td colspan="2"><div class="groupHeader"></div></td></tr>
<tr class="memitem:ab062142353dea0e5861291aa8c23c75c"><td class="memItemLeft" align="right" valign="top"><a id="ab062142353dea0e5861291aa8c23c75c"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>int_pair</b>&#160;&#160;&#160;pair&lt;int,int&gt;</td></tr>
<tr class="separator:ab062142353dea0e5861291aa8c23c75c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac1687d3c2da5679b67fd8eb9f462bdbe"><td class="memItemLeft" align="right" valign="top"><a id="ac1687d3c2da5679b67fd8eb9f462bdbe"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>double_pair</b>&#160;&#160;&#160;pair&lt;int_pair,int_pair&gt;</td></tr>
<tr class="separator:ac1687d3c2da5679b67fd8eb9f462bdbe"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ad8adb627af69a5ca371972a3c7e4f598"><td class="memItemLeft" align="right" valign="top">int **&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="dijkstra_8hpp.html#ad8adb627af69a5ca371972a3c7e4f598">alloc_mem_matrix</a> (int nr_nodes)</td></tr>
<tr class="memdesc:ad8adb627af69a5ca371972a3c7e4f598"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function for allocating variables to memory.  <a href="dijkstra_8hpp.html#ad8adb627af69a5ca371972a3c7e4f598">More...</a><br /></td></tr>
<tr class="separator:ad8adb627af69a5ca371972a3c7e4f598"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8785d51320fbcb9c339b45237444ced9"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="dijkstra_8hpp.html#a8785d51320fbcb9c339b45237444ced9">are_valid_nodes</a> (int, int, int, int, int)</td></tr>
<tr class="memdesc:a8785d51320fbcb9c339b45237444ced9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sanity check function.  <a href="dijkstra_8hpp.html#a8785d51320fbcb9c339b45237444ced9">More...</a><br /></td></tr>
<tr class="separator:a8785d51320fbcb9c339b45237444ced9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>File that contains the declaration of the struct <a class="el" href="structDijkstra__node.html" title="Dijkstra_node struct.">Dijkstra_node</a> and class <a class="el" href="classDijkstra.html" title="Dijkstra class.">Dijkstra</a>. </p>
</div><h2 class="groupheader">Function Documentation</h2>
<a id="ad8adb627af69a5ca371972a3c7e4f598"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad8adb627af69a5ca371972a3c7e4f598">&#9670;&nbsp;</a></span>alloc_mem_matrix()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int** alloc_mem_matrix </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>nr_nodes</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function for allocating variables to memory. </p>
<p>Similar to malloc.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">nr_nodes</td><td>The size that the variables will occupy in the memory. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="classDijkstra.html#a4c6686b282d5cf37a96c8c216dc84bef" title="The maze.">Dijkstra::maze</a> </dd>
<dd>
<a class="el" href="classDijkstra.html#a7994b590ca8f02bf1577adec2d5ac1c5" title="The visited nodes.">Dijkstra::visited</a> </dd>
<dd>
alloc_mem() </dd></dl>

</div>
</div>
<a id="a8785d51320fbcb9c339b45237444ced9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8785d51320fbcb9c339b45237444ced9">&#9670;&nbsp;</a></span>are_valid_nodes()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int are_valid_nodes </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>start_row</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>start_col</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>target_row</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>target_col</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>max</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sanity check function. </p>
<p>It is used to check if the starting node and target node are valid (they are in the boundries of the maze matrix.</p>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="classDijkstra.html#a324563e8b4f66022c85870e71064e38e" title="Starting node in the maze.">Dijkstra::starting_node</a> </dd>
<dd>
<a class="el" href="classDijkstra.html#a6cd0a788a66dc3c191d38050337687de" title="Target node in the maze.">Dijkstra::target_node</a> </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
